Index: Python-2.6.7/Include/pythonrun.h
===================================================================
--- Python-2.6.7.orig/Include/pythonrun.h	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Include/pythonrun.h	2012-02-08 18:42:58.000000000 +0100
@@ -108,6 +108,8 @@
 /* In their own files */
 PyAPI_FUNC(const char *) Py_GetVersion(void);
 PyAPI_FUNC(const char *) Py_GetPlatform(void);
+PyAPI_FUNC(const char *) Py_GetArch(void);
+PyAPI_FUNC(const char *) Py_GetLib(void);
 PyAPI_FUNC(const char *) Py_GetCopyright(void);
 PyAPI_FUNC(const char *) Py_GetCompiler(void);
 PyAPI_FUNC(const char *) Py_GetBuildInfo(void);
Index: Python-2.6.7/Lib/distutils/command/install.py
===================================================================
--- Python-2.6.7.orig/Lib/distutils/command/install.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Lib/distutils/command/install.py	2012-02-08 18:42:58.000000000 +0100
@@ -22,6 +22,8 @@
 from site import USER_SITE
 
 
+libname = sys.lib
+
 if sys.version < "2.2":
     WINDOWS_SCHEME = {
         'purelib': '$base',
@@ -41,15 +43,15 @@
 
 INSTALL_SCHEMES = {
     'unix_prefix': {
-        'purelib': '$base/lib/python$py_version_short/site-packages',
-        'platlib': '$platbase/lib/python$py_version_short/site-packages',
+        'purelib': '$base/'+libname+'/python$py_version_short/site-packages',
+        'platlib': '$platbase/'+libname+'/python$py_version_short/site-packages',
         'headers': '$base/include/python$py_version_short/$dist_name',
         'scripts': '$base/bin',
         'data'   : '$base',
         },
     'unix_home': {
-        'purelib': '$base/lib/python',
-        'platlib': '$base/lib/python',
+        'purelib': '$base/'+libname+'/python',
+        'platlib': '$base/'+libname+'/python',
         'headers': '$base/include/python/$dist_name',
         'scripts': '$base/bin',
         'data'   : '$base',
Index: Python-2.6.7/Lib/distutils/sysconfig.py
===================================================================
--- Python-2.6.7.orig/Lib/distutils/sysconfig.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Lib/distutils/sysconfig.py	2012-02-08 18:42:58.000000000 +0100
@@ -120,7 +120,7 @@
 
     if os.name == "posix":
         libpython = os.path.join(prefix,
-                                 "lib", "python" + get_python_version())
+                                 sys.lib, "python" + get_python_version())
         if standard_lib:
             return libpython
         else:
Index: Python-2.6.7/Lib/distutils/tests/test_install.py
===================================================================
--- Python-2.6.7.orig/Lib/distutils/tests/test_install.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Lib/distutils/tests/test_install.py	2012-02-08 18:42:58.000000000 +0100
@@ -1,6 +1,7 @@
 """Tests for distutils.command.install."""
 
 import os
+import sys
 import unittest
 
 from distutils.command.install import install
@@ -23,7 +24,7 @@
         dist.script_name = os.path.join(builddir, "setup.py")
         dist.command_obj["build"] = support.DummyCommand(
             build_base=builddir,
-            build_lib=os.path.join(builddir, "lib"),
+            build_lib=os.path.join(builddir, sys.lib),
             )
 
         cmd = install(dist)
@@ -38,7 +39,7 @@
             expected = os.path.normpath(expected)
             self.assertEqual(got, expected)
 
-        libdir = os.path.join(destination, "lib", "python")
+        libdir = os.path.join(destination, sys.lib, "python")
         check_path(cmd.install_lib, libdir)
         check_path(cmd.install_platlib, libdir)
         check_path(cmd.install_purelib, libdir)
Index: Python-2.6.7/Lib/pydoc.py
===================================================================
--- Python-2.6.7.orig/Lib/pydoc.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Lib/pydoc.py	2012-02-08 18:42:58.000000000 +0100
@@ -349,7 +349,7 @@
 
         docloc = os.environ.get("PYTHONDOCS",
                                 "http://docs.python.org/library")
-        basedir = os.path.join(sys.exec_prefix, "lib",
+        basedir = os.path.join(sys.exec_prefix, sys.lib,
                                "python"+sys.version[0:3])
         if (isinstance(object, type(os)) and
             (object.__name__ in ('errno', 'exceptions', 'gc', 'imp',
Index: Python-2.6.7/Lib/site.py
===================================================================
--- Python-2.6.7.orig/Lib/site.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Lib/site.py	2012-02-08 18:42:58.000000000 +0100
@@ -265,13 +265,13 @@
         if sys.platform in ('os2emx', 'riscos'):
             sitedirs.append(os.path.join(prefix, "Lib", "site-packages"))
         elif os.sep == '/':
-            sitedirs.append(os.path.join(prefix, "lib",
+            sitedirs.append(os.path.join(prefix, sys.lib,
                                         "python" + sys.version[:3],
                                         "site-packages"))
-            sitedirs.append(os.path.join(prefix, "lib", "site-python"))
+            sitedirs.append(os.path.join(prefix, sys.lib, "site-python"))
         else:
             sitedirs.append(prefix)
-            sitedirs.append(os.path.join(prefix, "lib", "site-packages"))
+            sitedirs.append(os.path.join(prefix, sys.lib, "site-packages"))
 
         if sys.platform == "darwin":
             # for framework builds *only* we add the standard Apple
Index: Python-2.6.7/Lib/test/test_dl.py
===================================================================
--- Python-2.6.7.orig/Lib/test/test_dl.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Lib/test/test_dl.py	2012-02-08 18:42:58.000000000 +0100
@@ -4,10 +4,11 @@
 """
 from test.test_support import verbose,TestSkipped, import_module
 dl = import_module('dl', deprecated=True)
+import sys
 
 sharedlibs = [
-    ('/usr/lib/libc.so', 'getpid'),
-    ('/lib/libc.so.6', 'getpid'),
+    ('/usr/'+sys.lib+'/libc.so', 'getpid'),
+    ('/'+sys.lib+'/libc.so.6', 'getpid'),
     ('/usr/bin/cygwin1.dll', 'getpid'),
     ('/usr/lib/libc.dylib', 'getpid'),
     ]
Index: Python-2.6.7/Lib/trace.py
===================================================================
--- Python-2.6.7.orig/Lib/trace.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Lib/trace.py	2012-02-08 18:42:58.000000000 +0100
@@ -759,10 +759,10 @@
                 # should I also call expanduser? (after all, could use $HOME)
 
                 s = s.replace("$prefix",
-                              os.path.join(sys.prefix, "lib",
+                              os.path.join(sys.prefix, sys.lib,
                                            "python" + sys.version[:3]))
                 s = s.replace("$exec_prefix",
-                              os.path.join(sys.exec_prefix, "lib",
+                              os.path.join(sys.exec_prefix, sys.lib,
                                            "python" + sys.version[:3]))
                 s = os.path.normpath(s)
                 ignore_dirs.append(s)
Index: Python-2.6.7/Makefile.pre.in
===================================================================
--- Python-2.6.7.orig/Makefile.pre.in	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Makefile.pre.in	2012-02-08 18:42:58.000000000 +0100
@@ -75,6 +75,8 @@
 
 # Machine-dependent subdirectories
 MACHDEP=	@MACHDEP@
+LIB=		@LIB@
+ARCH=		@ARCH@
 
 # Install prefix for architecture-independent files
 prefix=		@prefix@
@@ -509,6 +511,7 @@
 		-DEXEC_PREFIX='"$(exec_prefix)"' \
 		-DVERSION='"$(VERSION)"' \
 		-DVPATH='"$(VPATH)"' \
+		-DARCH='"$(ARCH)"' -DLIB='"$(LIB)"' \
 		-o $@ $(srcdir)/Modules/getpath.c
 
 Modules/python.o: $(srcdir)/Modules/python.c
@@ -540,7 +543,7 @@
 Python/compile.o Python/symtable.o: $(GRAMMAR_H) $(AST_H)
 
 Python/getplatform.o: $(srcdir)/Python/getplatform.c
-		$(CC) -c $(PY_CFLAGS) -DPLATFORM='"$(MACHDEP)"' -o $@ $(srcdir)/Python/getplatform.c
+		$(CC) -c $(PY_CFLAGS) -DPLATFORM='"$(MACHDEP)"' -DARCH='"$(ARCH)"' -DLIB='"$(LIB)"' -o $@ $(srcdir)/Python/getplatform.c
 
 Python/importdl.o: $(srcdir)/Python/importdl.c
 		$(CC) -c $(PY_CFLAGS) -I$(DLINCLDIR) -o $@ $(srcdir)/Python/importdl.c
Index: Python-2.6.7/Modules/getpath.c
===================================================================
--- Python-2.6.7.orig/Modules/getpath.c	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Modules/getpath.c	2012-02-08 18:42:58.000000000 +0100
@@ -116,9 +116,11 @@
 #define EXEC_PREFIX PREFIX
 #endif
 
+#define LIB_PYTHON LIB "/python" VERSION
+
 #ifndef PYTHONPATH
-#define PYTHONPATH PREFIX "/lib/python" VERSION ":" \
-              EXEC_PREFIX "/lib/python" VERSION "/lib-dynload"
+#define PYTHONPATH PREFIX "/" LIB_PYTHON ":" \
+              EXEC_PREFIX "/" LIB_PYTHON "/lib-dynload"
 #endif
 
 #ifndef LANDMARK
@@ -129,7 +131,7 @@
 static char exec_prefix[MAXPATHLEN+1];
 static char progpath[MAXPATHLEN+1];
 static char *module_search_path = NULL;
-static char lib_python[] = "lib/python" VERSION;
+static char lib_python[] = LIB_PYTHON;
 
 static void
 reduce(char *dir)
Index: Python-2.6.7/Python/getplatform.c
===================================================================
--- Python-2.6.7.orig/Python/getplatform.c	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Python/getplatform.c	2012-02-08 18:42:58.000000000 +0100
@@ -10,3 +10,23 @@
 {
 	return PLATFORM;
 }
+
+#ifndef ARCH
+#define ARCH "unknown"
+#endif
+
+const char *
+Py_GetArch(void)
+{
+	return ARCH;
+}
+
+#ifndef LIB
+#define LIB "lib"
+#endif
+
+const char *
+Py_GetLib(void)
+{
+	return LIB;
+}
Index: Python-2.6.7/Python/sysmodule.c
===================================================================
--- Python-2.6.7.orig/Python/sysmodule.c	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/Python/sysmodule.c	2012-02-08 18:42:58.000000000 +0100
@@ -1379,6 +1379,10 @@
                         PyString_FromString(Py_GetCopyright()));
     SET_SYS_FROM_STRING("platform",
                         PyString_FromString(Py_GetPlatform()));
+    SET_SYS_FROM_STRING("arch",
+                        PyString_FromString(Py_GetArch()));
+    SET_SYS_FROM_STRING("lib",
+                        PyString_FromString(Py_GetLib()));
     SET_SYS_FROM_STRING("executable",
                         PyString_FromString(Py_GetProgramFullPath()));
     SET_SYS_FROM_STRING("prefix",
Index: Python-2.6.7/configure.in
===================================================================
--- Python-2.6.7.orig/configure.in	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/configure.in	2012-02-08 18:42:58.000000000 +0100
@@ -613,6 +613,41 @@
     ;;
 esac
 
+AC_SUBST(ARCH)
+AC_MSG_CHECKING(ARCH)
+ARCH=`uname -m`
+case $ARCH in
+i?86) ARCH=i386;;
+esac
+AC_MSG_RESULT($ARCH)
+
+AC_SUBST(LIB)
+AC_MSG_CHECKING(LIB)
+case $ac_sys_system in
+Linux*)
+  # Test if the compiler is 64bit
+  echo 'int i;' > conftest.$ac_ext
+  python_cv_cc_64bit_output=no
+  if AC_TRY_EVAL(ac_compile); then
+    case `/usr/bin/file conftest.$ac_objext` in
+    *"ELF 64"*)
+      python_cv_cc_64bit_output=yes
+      ;;
+    esac
+  fi
+  rm -rf conftest*
+  ;;
+esac
+
+case $ARCH:$python_cv_cc_64bit_output in
+ppc64:yes | powerpc64:yes | s390x:yes | sparc64:yes | x86_64:yes)
+  LIB="lib64"
+  ;;
+*:*)
+  LIB="lib"
+  ;;
+esac
+AC_MSG_RESULT($LIB)
 
 AC_SUBST(LIBRARY)
 AC_MSG_CHECKING(LIBRARY)
Index: Python-2.6.7/setup.py
===================================================================
--- Python-2.6.7.orig/setup.py	2012-02-08 18:42:19.000000000 +0100
+++ Python-2.6.7/setup.py	2012-02-08 18:42:58.000000000 +0100
@@ -356,7 +356,7 @@
 
     def detect_modules(self):
         # Ensure that /usr/local is always used
-        add_dir_to_list(self.compiler.library_dirs, '/usr/local/lib')
+        add_dir_to_list(self.compiler.library_dirs, '/usr/local/' + sys.lib)
         add_dir_to_list(self.compiler.include_dirs, '/usr/local/include')
 
         # Add paths specified in the environment variables LDFLAGS and
@@ -408,8 +408,7 @@
         # if a file is found in one of those directories, it can
         # be assumed that no additional -I,-L directives are needed.
         lib_dirs = self.compiler.library_dirs + [
-            '/lib64', '/usr/lib64',
-            '/lib', '/usr/lib',
+            '/' + sys.lib, '/usr/' + sys.lib,
             ]
         inc_dirs = self.compiler.include_dirs + ['/usr/include']
         exts = []
@@ -662,11 +661,11 @@
             elif curses_library:
                 readline_libs.append(curses_library)
             elif self.compiler.find_library_file(lib_dirs +
-                                               ['/usr/lib/termcap'],
+                                               ['/usr/'+sys.lib+'/termcap'],
                                                'termcap'):
                 readline_libs.append('termcap')
             exts.append( Extension('readline', ['readline.c'],
-                                   library_dirs=['/usr/lib/termcap'],
+                                   library_dirs=['/usr/'+sys.lib+'/termcap'],
                                    extra_link_args=readline_extra_link_args,
                                    libraries=readline_libs) )
         else:
@@ -1716,18 +1715,17 @@
         # Check for various platform-specific directories
         if platform == 'sunos5':
             include_dirs.append('/usr/openwin/include')
-            added_lib_dirs.append('/usr/openwin/lib')
+            added_lib_dirs.append('/usr/openwin/' + sys.lib)
         elif os.path.exists('/usr/X11R6/include'):
             include_dirs.append('/usr/X11R6/include')
-            added_lib_dirs.append('/usr/X11R6/lib64')
-            added_lib_dirs.append('/usr/X11R6/lib')
+            added_lib_dirs.append('/usr/X11R6/' + sys.lib)
         elif os.path.exists('/usr/X11R5/include'):
             include_dirs.append('/usr/X11R5/include')
-            added_lib_dirs.append('/usr/X11R5/lib')
+            added_lib_dirs.append('/usr/X11R5/' + sys.lib)
         else:
             # Assume default location for X11
             include_dirs.append('/usr/X11/include')
-            added_lib_dirs.append('/usr/X11/lib')
+            added_lib_dirs.append('/usr/X11/' + sys.lib)
 
         # If Cygwin, then verify that X is installed before proceeding
         if platform == 'cygwin':
